diff -ruN qmail-1.03-orig/digest_md5.c qmail-1.03-ldap-20060201-orig/digest_md5.c
--- qmail-1.03-orig/digest_md5.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_md5.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,319 @@
+/* digest_md5.c for QLDAP modified to use djb's stuff  */
+/* contains MD5 algorithm stolen directly from OpenBSD */
+
+/*        */
+/*  MD5   */
+/*        */
+
+/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
+rights reserved.
+
+License to copy and use this software is granted provided that it
+is identified as the "RSA Data Security, Inc. MD5 Message-Digest
+Algorithm" in all material mentioning or referencing this software
+or this function.
+
+License is also granted to make and use derivative works provided
+that such works are identified as "derived from the RSA Data
+Security, Inc. MD5 Message-Digest Algorithm" in all material
+mentioning or referencing the derived work.
+
+RSA Data Security, Inc. makes no representations concerning either
+the merchantability of this software or the suitability of this
+software for any particular purpose. It is provided "as is"
+without express or implied warranty of any kind.
+
+These notices must be retained in any copies of any part of this
+documentation and/or software.
+ */
+
+#include <sys/types.h>
+#include "uint32.h"
+#include "byte.h"
+#include "digest_md5.h"
+
+/* POINTER defines a generic pointer type */
+typedef unsigned char *POINTER;
+
+/* Constants for MD5Transform routine.
+ */
+#define S11 7
+#define S12 12
+#define S13 17
+#define S14 22
+#define S21 5
+#define S22 9
+#define S23 14
+#define S24 20
+#define S31 4
+#define S32 11
+#define S33 16
+#define S34 23
+#define S41 6
+#define S42 10
+#define S43 15
+#define S44 21
+
+static void MD5Transform (uint32 [4], const unsigned char [64]);
+
+#ifdef __LITTLE_ENDIAN__
+#define Encode byte_copy
+#define Decode byte_copy
+#else  /* __BIG_ENDIAN__ */
+static void Encode(void *, size_t, const void *);
+static void Decode(void *, size_t, const void *);
+#endif /* __LITTLE_ENDIAN__ */
+
+static unsigned char PADDING[64] = {
+  0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
+/* F, G, H and I are basic MD5 functions.
+ */
+#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
+#define G(x, y, z) (((x) & (z)) | ((y) & (~z)))
+#define H(x, y, z) ((x) ^ (y) ^ (z))
+#define I(x, y, z) ((y) ^ ((x) | (~z)))
+
+/* ROTATE_LEFT rotates x left n bits.
+ */
+#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))
+
+/* FF, GG, HH, and II transformations for rounds 1, 2, 3, and 4.
+Rotation is separate from addition to prevent recomputation.
+ */
+#define FF(a, b, c, d, x, s, ac) { \
+ (a) += F ((b), (c), (d)) + (x) + (uint32)(ac); \
+ (a) = ROTATE_LEFT ((a), (s)); \
+ (a) += (b); \
+  }
+#define GG(a, b, c, d, x, s, ac) { \
+ (a) += G ((b), (c), (d)) + (x) + (uint32)(ac); \
+ (a) = ROTATE_LEFT ((a), (s)); \
+ (a) += (b); \
+  }
+#define HH(a, b, c, d, x, s, ac) { \
+ (a) += H ((b), (c), (d)) + (x) + (uint32)(ac); \
+ (a) = ROTATE_LEFT ((a), (s)); \
+ (a) += (b); \
+  }
+#define II(a, b, c, d, x, s, ac) { \
+ (a) += I ((b), (c), (d)) + (x) + (uint32)(ac); \
+ (a) = ROTATE_LEFT ((a), (s)); \
+ (a) += (b); \
+  }
+
+#ifdef __BIG_ENDIAN__
+/* Encodes input (uint32) into output (unsigned char). Assumes len is
+  a multiple of 4.
+ */
+static void
+Encode(void *out, size_t len, const void *in)
+{
+  unsigned char *output = out;
+  size_t i, j;
+  const uint32 *input = in;
+
+  for (i = 0, j = 0; j < len; i++, j += 4) {
+    output[j] = (unsigned char)(input[i] & 0xff);
+    output[j+1] = (unsigned char)((input[i] >> 8) & 0xff);
+    output[j+2] = (unsigned char)((input[i] >> 16) & 0xff);
+    output[j+3] = (unsigned char)((input[i] >> 24) & 0xff);
+  }
+}
+
+/* Decodes input (unsigned char) into output (uint32). Assumes len is
+  a multiple of 4.
+ */
+static void
+Decode(void *out, size_t len, const void *in)
+{
+  uint32 *output = out;
+  const unsigned char *input = in;
+  size_t i, j;
+
+  for (i = 0, j = 0; j < len; i++, j += 4)
+    output[i] = ((uint32)input[j]) | (((uint32)input[j+1]) << 8) |
+    (((uint32)input[j+2]) << 16) | (((uint32)input[j+3]) << 24);
+}
+#endif /* __BIG_ENDIAN__ */
+
+/* MD5 initialization. Begins an MD5 operation, writing a new context.
+ */
+void
+MD5Init(MD5_CTX *context)
+{
+  context->count[0] = 0;
+  context->count[1] = 0;
+
+  /* Load magic initialization constants. */
+  context->state[0] = 0x67452301;
+  context->state[1] = 0xefcdab89;
+  context->state[2] = 0x98badcfe;
+  context->state[3] = 0x10325476;
+}
+
+/* MD5 block update operation. Continues an MD5 message-digest
+  operation, processing another message block, and updating the
+  context.
+ */
+void
+MD5Update(MD5_CTX *context, const unsigned char *input, size_t inputLen)
+{
+  unsigned int i, idx, partLen;
+
+  /* Compute number of bytes mod 64 */
+  idx = (unsigned int)((context->count[0] >> 3) & 0x3F);
+
+  /* Update number of bits */
+  if ( (context->count[0] += ((uint32)inputLen << 3)) /* lower part of count */
+       < ((uint32)inputLen << 3) )
+    context->count[1]++; /* low part of count overflowed */
+
+  context->count[1] += ((uint32)inputLen >> 29); /* update high part of count */
+
+  partLen = 64 - idx;
+
+  /* Transform as many times as possible. */
+  if (inputLen >= partLen) {
+    byte_copy ((POINTER)&context->buffer[idx], partLen, input);
+    MD5Transform (context->state, context->buffer);
+
+    for (i = partLen; i + 63 < inputLen; i += 64)
+      MD5Transform (context->state, &input[i]);
+
+    idx = 0;
+  }
+  else
+    i = 0;
+
+  /* Buffer remaining input */
+  byte_copy ((POINTER)&context->buffer[idx], inputLen-i, &input[i]);
+}
+
+/* MD5 finalization. Ends an MD5 message-digest operation, writing the
+  the message digest and zeroizing the context.
+ */
+void
+MD5Final(unsigned char digest[MD5_LEN], MD5_CTX *context)
+{
+  unsigned char bits[8];
+  unsigned int idx;
+  size_t padLen;
+  uint32 hi, lo;
+
+  /* Save number of bits */
+  hi = context->count[1];
+  lo = context->count[0];
+  Encode (bits, 4, &lo);
+  Encode (bits + 4, 4, &hi);
+
+  /* Pad out to 56 mod 64. */
+  idx = (unsigned int)((context->count[0] >> 3) & 0x3f);
+  padLen = (idx < 56) ? (56 - idx) : (120 - idx);
+  MD5Update (context, PADDING, padLen);
+
+  /* Append length (before padding) */
+  MD5Update (context, bits, 8);
+
+  if (digest != (unsigned char *)0) {
+    /* Store state in digest */
+    Encode (digest, 16, context->state);
+
+    /* Zeroize sensitive information.  */
+    byte_zero ((POINTER)context, sizeof (*context));
+  }
+}
+
+/* MD5 basic transformation. Transforms state based on block.
+ */
+static void
+MD5Transform(uint32 state[4], const unsigned char block[64])
+{
+  uint32 a = state[0], b = state[1], c = state[2], d = state[3], x[16];
+
+  Decode (x, 64, block);
+
+  /* Round 1 */
+  FF (a, b, c, d, x[ 0], S11, 0xd76aa478); /* 1 */
+  FF (d, a, b, c, x[ 1], S12, 0xe8c7b756); /* 2 */
+  FF (c, d, a, b, x[ 2], S13, 0x242070db); /* 3 */
+  FF (b, c, d, a, x[ 3], S14, 0xc1bdceee); /* 4 */
+  FF (a, b, c, d, x[ 4], S11, 0xf57c0faf); /* 5 */
+  FF (d, a, b, c, x[ 5], S12, 0x4787c62a); /* 6 */
+  FF (c, d, a, b, x[ 6], S13, 0xa8304613); /* 7 */
+  FF (b, c, d, a, x[ 7], S14, 0xfd469501); /* 8 */
+  FF (a, b, c, d, x[ 8], S11, 0x698098d8); /* 9 */
+  FF (d, a, b, c, x[ 9], S12, 0x8b44f7af); /* 10 */
+  FF (c, d, a, b, x[10], S13, 0xffff5bb1); /* 11 */
+  FF (b, c, d, a, x[11], S14, 0x895cd7be); /* 12 */
+  FF (a, b, c, d, x[12], S11, 0x6b901122); /* 13 */
+  FF (d, a, b, c, x[13], S12, 0xfd987193); /* 14 */
+  FF (c, d, a, b, x[14], S13, 0xa679438e); /* 15 */
+  FF (b, c, d, a, x[15], S14, 0x49b40821); /* 16 */
+
+ /* Round 2 */
+  GG (a, b, c, d, x[ 1], S21, 0xf61e2562); /* 17 */
+  GG (d, a, b, c, x[ 6], S22, 0xc040b340); /* 18 */
+  GG (c, d, a, b, x[11], S23, 0x265e5a51); /* 19 */
+  GG (b, c, d, a, x[ 0], S24, 0xe9b6c7aa); /* 20 */
+  GG (a, b, c, d, x[ 5], S21, 0xd62f105d); /* 21 */
+  GG (d, a, b, c, x[10], S22,  0x2441453); /* 22 */
+  GG (c, d, a, b, x[15], S23, 0xd8a1e681); /* 23 */
+  GG (b, c, d, a, x[ 4], S24, 0xe7d3fbc8); /* 24 */
+  GG (a, b, c, d, x[ 9], S21, 0x21e1cde6); /* 25 */
+  GG (d, a, b, c, x[14], S22, 0xc33707d6); /* 26 */
+  GG (c, d, a, b, x[ 3], S23, 0xf4d50d87); /* 27 */
+  GG (b, c, d, a, x[ 8], S24, 0x455a14ed); /* 28 */
+  GG (a, b, c, d, x[13], S21, 0xa9e3e905); /* 29 */
+  GG (d, a, b, c, x[ 2], S22, 0xfcefa3f8); /* 30 */
+  GG (c, d, a, b, x[ 7], S23, 0x676f02d9); /* 31 */
+  GG (b, c, d, a, x[12], S24, 0x8d2a4c8a); /* 32 */
+
+  /* Round 3 */
+  HH (a, b, c, d, x[ 5], S31, 0xfffa3942); /* 33 */
+  HH (d, a, b, c, x[ 8], S32, 0x8771f681); /* 34 */
+  HH (c, d, a, b, x[11], S33, 0x6d9d6122); /* 35 */
+  HH (b, c, d, a, x[14], S34, 0xfde5380c); /* 36 */
+  HH (a, b, c, d, x[ 1], S31, 0xa4beea44); /* 37 */
+  HH (d, a, b, c, x[ 4], S32, 0x4bdecfa9); /* 38 */
+  HH (c, d, a, b, x[ 7], S33, 0xf6bb4b60); /* 39 */
+  HH (b, c, d, a, x[10], S34, 0xbebfbc70); /* 40 */
+  HH (a, b, c, d, x[13], S31, 0x289b7ec6); /* 41 */
+  HH (d, a, b, c, x[ 0], S32, 0xeaa127fa); /* 42 */
+  HH (c, d, a, b, x[ 3], S33, 0xd4ef3085); /* 43 */
+  HH (b, c, d, a, x[ 6], S34,  0x4881d05); /* 44 */
+  HH (a, b, c, d, x[ 9], S31, 0xd9d4d039); /* 45 */
+  HH (d, a, b, c, x[12], S32, 0xe6db99e5); /* 46 */
+  HH (c, d, a, b, x[15], S33, 0x1fa27cf8); /* 47 */
+  HH (b, c, d, a, x[ 2], S34, 0xc4ac5665); /* 48 */
+
+  /* Round 4 */
+  II (a, b, c, d, x[ 0], S41, 0xf4292244); /* 49 */
+  II (d, a, b, c, x[ 7], S42, 0x432aff97); /* 50 */
+  II (c, d, a, b, x[14], S43, 0xab9423a7); /* 51 */
+  II (b, c, d, a, x[ 5], S44, 0xfc93a039); /* 52 */
+  II (a, b, c, d, x[12], S41, 0x655b59c3); /* 53 */
+  II (d, a, b, c, x[ 3], S42, 0x8f0ccc92); /* 54 */
+  II (c, d, a, b, x[10], S43, 0xffeff47d); /* 55 */
+  II (b, c, d, a, x[ 1], S44, 0x85845dd1); /* 56 */
+  II (a, b, c, d, x[ 8], S41, 0x6fa87e4f); /* 57 */
+  II (d, a, b, c, x[15], S42, 0xfe2ce6e0); /* 58 */
+  II (c, d, a, b, x[ 6], S43, 0xa3014314); /* 59 */
+  II (b, c, d, a, x[13], S44, 0x4e0811a1); /* 60 */
+  II (a, b, c, d, x[ 4], S41, 0xf7537e82); /* 61 */
+  II (d, a, b, c, x[11], S42, 0xbd3af235); /* 62 */
+  II (c, d, a, b, x[ 2], S43, 0x2ad7d2bb); /* 63 */
+  II (b, c, d, a, x[ 9], S44, 0xeb86d391); /* 64 */
+
+  state[0] += a;
+  state[1] += b;
+  state[2] += c;
+  state[3] += d;
+
+  /* Zeroize sensitive information. */
+  byte_zero ((POINTER)x, sizeof (x));
+}
+
diff -ruN qmail-1.03-orig/digest_md5.h qmail-1.03-ldap-20060201-orig/digest_md5.h
--- qmail-1.03-orig/digest_md5.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_md5.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,47 @@
+/* digest_md5.h for QLDAP modified to use djb's stuff */
+
+/*        */
+/*  MD5   */
+/*        */
+
+/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
+rights reserved.
+
+License to copy and use this software is granted provided that it
+is identified as the "RSA Data Security, Inc. MD5 Message-Digest
+Algorithm" in all material mentioning or referencing this software
+or this function.
+
+License is also granted to make and use derivative works provided
+that such works are identified as "derived from the RSA Data
+Security, Inc. MD5 Message-Digest Algorithm" in all material
+mentioning or referencing the derived work.
+
+RSA Data Security, Inc. makes no representations concerning either
+the merchantability of this software or the suitability of this
+software for any particular purpose. It is provided "as is"
+without express or implied warranty of any kind.
+
+These notices must be retained in any copies of any part of this
+documentation and/or software.
+ */
+
+#ifndef _MD5_H_
+#define _MD5_H_
+
+#include "uint32.h"
+
+/* MD5 context. */
+typedef struct MD5Context {
+    uint32 state[4];            /* state (ABCD) */
+    uint32 count[2];            /* number of bits, modulo 2^64 */
+    unsigned char buffer[64];   /* input buffer */
+} MD5_CTX;
+
+#define MD5_LEN 16
+
+void   MD5Init(MD5_CTX *);
+void   MD5Update(MD5_CTX *, const unsigned char *, size_t);
+void   MD5Final(unsigned char [MD5_LEN], MD5_CTX *);
+
+#endif /* _MD5_H_ */
diff -ruN qmail-1.03-orig/digest_rmd160.c qmail-1.03-ldap-20060201-orig/digest_rmd160.c
--- qmail-1.03-orig/digest_rmd160.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_rmd160.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,412 @@
+/* digest_rmd160.c for QLDAP checkpassword.c              */
+/* contains RMD160 algorithm stolen directly from OpenBSD */
+
+/*        */
+/* RMD160 */
+/*        */
+
+/********************************************************************\
+ *
+ *      FILE:     rmd160.c
+ *
+ *      CONTENTS: A sample C-implementation of the RIPEMD-160
+ *                hash-function.
+ *      TARGET:   any computer with an ANSI C compiler
+ *
+ *      AUTHOR:   Antoon Bosselaers, ESAT-COSIC
+ *                (Arranged for libc by Todd C. Miller)
+ *      DATE:     1 March 1996
+ *      VERSION:  1.0
+ *
+ *      Copyright (c) Katholieke Universiteit Leuven
+ *      1996, All Rights Reserved
+ *
+\********************************************************************/
+
+/*  header files */
+#include <sys/types.h>
+#include "uint32.h"
+#include "byte.h"
+#include "digest_rmd160.h"
+
+/* macro definitions */
+
+/* collect four bytes into one word: */
+#define BYTES_TO_DWORD(strptr)                  \
+    (((uint32) *((strptr)+3) << 24) |        \
+    ((uint32) *((strptr)+2) << 16) |         \
+    ((uint32) *((strptr)+1) <<  8) |         \
+    ((uint32) *(strptr)))
+
+/* ROL(x, n) cyclically rotates x over n bits to the left */
+/* x must be of an unsigned 32 bits type and 0 <= n < 32. */
+#define ROL(x, n)       (((x) << (n)) | ((x) >> (32-(n))))
+
+/* the three basic functions F(), G() and H() */
+#define F(x, y, z)      ((x) ^ (y) ^ (z))
+#define G(x, y, z)      (((x) & (y)) | (~(x) & (z)))
+#define H(x, y, z)      (((x) | ~(y)) ^ (z))
+#define I(x, y, z)      (((x) & (z)) | ((y) & ~(z)))
+#define J(x, y, z)      ((x) ^ ((y) | ~(z)))
+
+/* the eight basic operations FF() through III() */
+#define FF(a, b, c, d, e, x, s) {                       \
+      (a) += F((b), (c), (d)) + (x);                    \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define GG(a, b, c, d, e, x, s) {                       \
+      (a) += G((b), (c), (d)) + (x) + 0x5a827999U;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define HH(a, b, c, d, e, x, s) {                       \
+      (a) += H((b), (c), (d)) + (x) + 0x6ed9eba1U;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define II(a, b, c, d, e, x, s) {                       \
+      (a) += I((b), (c), (d)) + (x) + 0x8f1bbcdcU;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define JJ(a, b, c, d, e, x, s) {                       \
+      (a) += J((b), (c), (d)) + (x) + 0xa953fd4eU;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define FFF(a, b, c, d, e, x, s)        {               \
+      (a) += F((b), (c), (d)) + (x);                    \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define GGG(a, b, c, d, e, x, s)        {               \
+      (a) += G((b), (c), (d)) + (x) + 0x7a6d76e9U;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define HHH(a, b, c, d, e, x, s)        {               \
+      (a) += H((b), (c), (d)) + (x) + 0x6d703ef3U;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define III(a, b, c, d, e, x, s)        {               \
+      (a) += I((b), (c), (d)) + (x) + 0x5c4dd124U;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+#define JJJ(a, b, c, d, e, x, s)        {               \
+      (a) += J((b), (c), (d)) + (x) + 0x50a28be6U;      \
+      (a) = ROL((a), (s)) + (e);                        \
+      (c) = ROL((c), 10);                               \
+}
+
+void
+RMD160Init(RMD160_CTX *context)
+{
+
+        /* ripemd-160 initialization constants */
+        context->state[0] = 0x67452301U;
+        context->state[1] = 0xefcdab89U;
+        context->state[2] = 0x98badcfeU;
+        context->state[3] = 0x10325476U;
+        context->state[4] = 0xc3d2e1f0U;
+        context->length[0] = context->length[1] = 0;
+        context->buflen = 0;
+}
+
+static void
+RMD160Transform(uint32 state[5], const uint32 block[16])
+{
+        uint32 aa = state[0],  bb = state[1],  cc = state[2],
+            dd = state[3],  ee = state[4];
+        uint32 aaa = state[0], bbb = state[1], ccc = state[2],
+            ddd = state[3], eee = state[4];
+
+        /* round 1 */
+        FF(aa, bb, cc, dd, ee, block[ 0], 11);
+        FF(ee, aa, bb, cc, dd, block[ 1], 14);
+        FF(dd, ee, aa, bb, cc, block[ 2], 15);
+        FF(cc, dd, ee, aa, bb, block[ 3], 12);
+        FF(bb, cc, dd, ee, aa, block[ 4],  5);
+        FF(aa, bb, cc, dd, ee, block[ 5],  8);
+        FF(ee, aa, bb, cc, dd, block[ 6],  7);
+        FF(dd, ee, aa, bb, cc, block[ 7],  9);
+        FF(cc, dd, ee, aa, bb, block[ 8], 11);
+        FF(bb, cc, dd, ee, aa, block[ 9], 13);
+        FF(aa, bb, cc, dd, ee, block[10], 14);
+        FF(ee, aa, bb, cc, dd, block[11], 15);
+        FF(dd, ee, aa, bb, cc, block[12],  6);
+        FF(cc, dd, ee, aa, bb, block[13],  7);
+        FF(bb, cc, dd, ee, aa, block[14],  9);
+        FF(aa, bb, cc, dd, ee, block[15],  8);
+
+        /* round 2 */
+        GG(ee, aa, bb, cc, dd, block[ 7],  7);
+        GG(dd, ee, aa, bb, cc, block[ 4],  6);
+        GG(cc, dd, ee, aa, bb, block[13],  8);
+        GG(bb, cc, dd, ee, aa, block[ 1], 13);
+        GG(aa, bb, cc, dd, ee, block[10], 11);
+        GG(ee, aa, bb, cc, dd, block[ 6],  9);
+        GG(dd, ee, aa, bb, cc, block[15],  7);
+        GG(cc, dd, ee, aa, bb, block[ 3], 15);
+        GG(bb, cc, dd, ee, aa, block[12],  7);
+        GG(aa, bb, cc, dd, ee, block[ 0], 12);
+        GG(ee, aa, bb, cc, dd, block[ 9], 15);
+        GG(dd, ee, aa, bb, cc, block[ 5],  9);
+        GG(cc, dd, ee, aa, bb, block[ 2], 11);
+        GG(bb, cc, dd, ee, aa, block[14],  7);
+        GG(aa, bb, cc, dd, ee, block[11], 13);
+        GG(ee, aa, bb, cc, dd, block[ 8], 12);
+
+        /* round 3 */
+        HH(dd, ee, aa, bb, cc, block[ 3], 11);
+        HH(cc, dd, ee, aa, bb, block[10], 13);
+        HH(bb, cc, dd, ee, aa, block[14],  6);
+        HH(aa, bb, cc, dd, ee, block[ 4],  7);
+        HH(ee, aa, bb, cc, dd, block[ 9], 14);
+        HH(dd, ee, aa, bb, cc, block[15],  9);
+        HH(cc, dd, ee, aa, bb, block[ 8], 13);
+        HH(bb, cc, dd, ee, aa, block[ 1], 15);
+        HH(aa, bb, cc, dd, ee, block[ 2], 14);
+        HH(ee, aa, bb, cc, dd, block[ 7],  8);
+        HH(dd, ee, aa, bb, cc, block[ 0], 13);
+        HH(cc, dd, ee, aa, bb, block[ 6],  6);
+        HH(bb, cc, dd, ee, aa, block[13],  5);
+        HH(aa, bb, cc, dd, ee, block[11], 12);
+        HH(ee, aa, bb, cc, dd, block[ 5],  7);
+        HH(dd, ee, aa, bb, cc, block[12],  5);
+
+        /* round 4 */
+        II(cc, dd, ee, aa, bb, block[ 1], 11);
+        II(bb, cc, dd, ee, aa, block[ 9], 12);
+        II(aa, bb, cc, dd, ee, block[11], 14);
+        II(ee, aa, bb, cc, dd, block[10], 15);
+        II(dd, ee, aa, bb, cc, block[ 0], 14);
+        II(cc, dd, ee, aa, bb, block[ 8], 15);
+        II(bb, cc, dd, ee, aa, block[12],  9);
+        II(aa, bb, cc, dd, ee, block[ 4],  8);
+        II(ee, aa, bb, cc, dd, block[13],  9);
+        II(dd, ee, aa, bb, cc, block[ 3], 14);
+        II(cc, dd, ee, aa, bb, block[ 7],  5);
+        II(bb, cc, dd, ee, aa, block[15],  6);
+        II(aa, bb, cc, dd, ee, block[14],  8);
+        II(ee, aa, bb, cc, dd, block[ 5],  6);
+        II(dd, ee, aa, bb, cc, block[ 6],  5);
+        II(cc, dd, ee, aa, bb, block[ 2], 12);
+
+        /* round 5 */
+        JJ(bb, cc, dd, ee, aa, block[ 4],  9);
+        JJ(aa, bb, cc, dd, ee, block[ 0], 15);
+        JJ(ee, aa, bb, cc, dd, block[ 5],  5);
+        JJ(dd, ee, aa, bb, cc, block[ 9], 11);
+        JJ(cc, dd, ee, aa, bb, block[ 7],  6);
+        JJ(bb, cc, dd, ee, aa, block[12],  8);
+        JJ(aa, bb, cc, dd, ee, block[ 2], 13);
+        JJ(ee, aa, bb, cc, dd, block[10], 12);
+        JJ(dd, ee, aa, bb, cc, block[14],  5);
+        JJ(cc, dd, ee, aa, bb, block[ 1], 12);
+        JJ(bb, cc, dd, ee, aa, block[ 3], 13);
+        JJ(aa, bb, cc, dd, ee, block[ 8], 14);
+        JJ(ee, aa, bb, cc, dd, block[11], 11);
+        JJ(dd, ee, aa, bb, cc, block[ 6],  8);
+        JJ(cc, dd, ee, aa, bb, block[15],  5);
+        JJ(bb, cc, dd, ee, aa, block[13],  6);
+
+        /* parallel round 1 */
+        JJJ(aaa, bbb, ccc, ddd, eee, block[ 5],  8);
+        JJJ(eee, aaa, bbb, ccc, ddd, block[14],  9);
+        JJJ(ddd, eee, aaa, bbb, ccc, block[ 7],  9);
+        JJJ(ccc, ddd, eee, aaa, bbb, block[ 0], 11);
+        JJJ(bbb, ccc, ddd, eee, aaa, block[ 9], 13);
+        JJJ(aaa, bbb, ccc, ddd, eee, block[ 2], 15);
+        JJJ(eee, aaa, bbb, ccc, ddd, block[11], 15);
+        JJJ(ddd, eee, aaa, bbb, ccc, block[ 4],  5);
+        JJJ(ccc, ddd, eee, aaa, bbb, block[13],  7);
+        JJJ(bbb, ccc, ddd, eee, aaa, block[ 6],  7);
+        JJJ(aaa, bbb, ccc, ddd, eee, block[15],  8);
+        JJJ(eee, aaa, bbb, ccc, ddd, block[ 8], 11);
+        JJJ(ddd, eee, aaa, bbb, ccc, block[ 1], 14);
+        JJJ(ccc, ddd, eee, aaa, bbb, block[10], 14);
+        JJJ(bbb, ccc, ddd, eee, aaa, block[ 3], 12);
+        JJJ(aaa, bbb, ccc, ddd, eee, block[12],  6);
+
+        /* parallel round 2 */
+        III(eee, aaa, bbb, ccc, ddd, block[ 6],  9);
+        III(ddd, eee, aaa, bbb, ccc, block[11], 13);
+        III(ccc, ddd, eee, aaa, bbb, block[ 3], 15);
+        III(bbb, ccc, ddd, eee, aaa, block[ 7],  7);
+        III(aaa, bbb, ccc, ddd, eee, block[ 0], 12);
+        III(eee, aaa, bbb, ccc, ddd, block[13],  8);
+        III(ddd, eee, aaa, bbb, ccc, block[ 5],  9);
+        III(ccc, ddd, eee, aaa, bbb, block[10], 11);
+        III(bbb, ccc, ddd, eee, aaa, block[14],  7);
+        III(aaa, bbb, ccc, ddd, eee, block[15],  7);
+        III(eee, aaa, bbb, ccc, ddd, block[ 8], 12);
+        III(ddd, eee, aaa, bbb, ccc, block[12],  7);
+        III(ccc, ddd, eee, aaa, bbb, block[ 4],  6);
+        III(bbb, ccc, ddd, eee, aaa, block[ 9], 15);
+        III(aaa, bbb, ccc, ddd, eee, block[ 1], 13);
+        III(eee, aaa, bbb, ccc, ddd, block[ 2], 11);
+
+        /* parallel round 3 */
+        HHH(ddd, eee, aaa, bbb, ccc, block[15],  9);
+        HHH(ccc, ddd, eee, aaa, bbb, block[ 5],  7);
+        HHH(bbb, ccc, ddd, eee, aaa, block[ 1], 15);
+        HHH(aaa, bbb, ccc, ddd, eee, block[ 3], 11);
+        HHH(eee, aaa, bbb, ccc, ddd, block[ 7],  8);
+        HHH(ddd, eee, aaa, bbb, ccc, block[14],  6);
+        HHH(ccc, ddd, eee, aaa, bbb, block[ 6],  6);
+        HHH(bbb, ccc, ddd, eee, aaa, block[ 9], 14);
+        HHH(aaa, bbb, ccc, ddd, eee, block[11], 12);
+        HHH(eee, aaa, bbb, ccc, ddd, block[ 8], 13);
+        HHH(ddd, eee, aaa, bbb, ccc, block[12],  5);
+        HHH(ccc, ddd, eee, aaa, bbb, block[ 2], 14);
+        HHH(bbb, ccc, ddd, eee, aaa, block[10], 13);
+        HHH(aaa, bbb, ccc, ddd, eee, block[ 0], 13);
+        HHH(eee, aaa, bbb, ccc, ddd, block[ 4],  7);
+        HHH(ddd, eee, aaa, bbb, ccc, block[13],  5);
+
+        /* parallel round 4 */
+        GGG(ccc, ddd, eee, aaa, bbb, block[ 8], 15);
+        GGG(bbb, ccc, ddd, eee, aaa, block[ 6],  5);
+        GGG(aaa, bbb, ccc, ddd, eee, block[ 4],  8);
+        GGG(eee, aaa, bbb, ccc, ddd, block[ 1], 11);
+        GGG(ddd, eee, aaa, bbb, ccc, block[ 3], 14);
+        GGG(ccc, ddd, eee, aaa, bbb, block[11], 14);
+        GGG(bbb, ccc, ddd, eee, aaa, block[15],  6);
+        GGG(aaa, bbb, ccc, ddd, eee, block[ 0], 14);
+        GGG(eee, aaa, bbb, ccc, ddd, block[ 5],  6);
+        GGG(ddd, eee, aaa, bbb, ccc, block[12],  9);
+        GGG(ccc, ddd, eee, aaa, bbb, block[ 2], 12);
+        GGG(bbb, ccc, ddd, eee, aaa, block[13],  9);
+        GGG(aaa, bbb, ccc, ddd, eee, block[ 9], 12);
+        GGG(eee, aaa, bbb, ccc, ddd, block[ 7],  5);
+        GGG(ddd, eee, aaa, bbb, ccc, block[10], 15);
+        GGG(ccc, ddd, eee, aaa, bbb, block[14],  8);
+
+        /* parallel round 5 */
+        FFF(bbb, ccc, ddd, eee, aaa, block[12] ,  8);
+        FFF(aaa, bbb, ccc, ddd, eee, block[15] ,  5);
+        FFF(eee, aaa, bbb, ccc, ddd, block[10] , 12);
+        FFF(ddd, eee, aaa, bbb, ccc, block[ 4] ,  9);
+        FFF(ccc, ddd, eee, aaa, bbb, block[ 1] , 12);
+        FFF(bbb, ccc, ddd, eee, aaa, block[ 5] ,  5);
+        FFF(aaa, bbb, ccc, ddd, eee, block[ 8] , 14);
+        FFF(eee, aaa, bbb, ccc, ddd, block[ 7] ,  6);
+        FFF(ddd, eee, aaa, bbb, ccc, block[ 6] ,  8);
+        FFF(ccc, ddd, eee, aaa, bbb, block[ 2] , 13);
+        FFF(bbb, ccc, ddd, eee, aaa, block[13] ,  6);
+        FFF(aaa, bbb, ccc, ddd, eee, block[14] ,  5);
+        FFF(eee, aaa, bbb, ccc, ddd, block[ 0] , 15);
+        FFF(ddd, eee, aaa, bbb, ccc, block[ 3] , 13);
+        FFF(ccc, ddd, eee, aaa, bbb, block[ 9] , 11);
+        FFF(bbb, ccc, ddd, eee, aaa, block[11] , 11);
+
+        /* combine results */
+        ddd += cc + state[1];           /* final result for state[0] */
+        state[1] = state[2] + dd + eee;
+        state[2] = state[3] + ee + aaa;
+        state[3] = state[4] + aa + bbb;
+        state[4] = state[0] + bb + ccc;
+        state[0] = ddd;
+}
+
+void
+RMD160Update(RMD160_CTX *context, const unsigned char *data, size_t nbytes)
+{
+        uint32 X[16];
+        uint32 ofs = 0;
+        uint32 i;
+#ifdef __BIG_ENDIAN__
+        uint32 j;
+#endif /* __BIG_ENDIAN__ */
+
+        /* update length[] */
+        if (context->length[0] + nbytes < context->length[0])
+                context->length[1]++;           /* overflow to msb of length */
+        context->length[0] += nbytes;
+
+        byte_zero(X, sizeof(X));
+
+        if ( context->buflen + nbytes < 64 )
+        {
+                byte_copy(context->bbuffer + context->buflen, nbytes, data);
+                context->buflen += nbytes;
+        }
+        else
+        {
+                /* process first block */
+                ofs = 64 - context->buflen;
+                byte_copy(context->bbuffer + context->buflen, ofs, data);
+#ifdef __LITTLE_ENDIAN__
+                byte_copy(X, sizeof(X), context->bbuffer);
+#else  /* __BIG_ENDIAN__ */
+                for (j=0; j < 16; j++)
+                        X[j] = BYTES_TO_DWORD(context->bbuffer + (4 * j));
+#endif /* __LITTLE_ENDIAN__ */
+                RMD160Transform(context->state, X);
+                nbytes -= ofs;
+
+                /* process remaining complete blocks */
+                for (i = 0; i < (nbytes >> 6); i++) {
+#ifdef __LITTLE_ENDIAN__
+                        byte_copy(X, sizeof(X), data + (64 * i) + ofs);
+#else  /* __BIG_ENDIAN__ */
+                        for (j=0; j < 16; j++)
+                                X[j] = BYTES_TO_DWORD(data + (64 * i) + (4 * j) + ofs);
+#endif /* __LITTLE_ENDIAN__ */
+                        RMD160Transform(context->state, X);
+                }
+
+                /*
+                 * Put last bytes from data into context's buffer
+                 */
+                context->buflen = nbytes & 63;
+                byte_copy(context->bbuffer, context->buflen, data + (64 * i) + ofs);
+        }
+}
+
+void
+RMD160Final(unsigned char digest[RMD160_LEN], RMD160_CTX *context)
+{
+        uint32 i;
+        uint32 X[16];
+#ifdef __BIG_ENDIAN__
+        uint32 j;
+#endif /* __BIG_ENDIAN__ */
+
+        /* append the bit m_n == 1 */
+        context->bbuffer[context->buflen] = '\200';
+
+        byte_zero(context->bbuffer + context->buflen + 1,
+                63 - context->buflen);
+#ifdef __LITTLE_ENDIAN__
+        byte_copy(X, sizeof(X), context->bbuffer);
+#else  /* __BIG_ENDIAN__ */
+        for (j=0; j < 16; j++)
+                X[j] = BYTES_TO_DWORD(context->bbuffer + (4 * j));
+#endif /* __LITTLE_ENDIAN__ */
+        if ((context->buflen) > 55) {
+                /* length goes to next block */
+                RMD160Transform(context->state, X);
+                byte_zero(X, sizeof(X));
+        }
+
+        /* append length in bits */
+        X[14] = context->length[0] << 3;
+        X[15] = (context->length[0] >> 29) |
+            (context->length[1] << 3);
+        RMD160Transform(context->state, X);
+
+        if (digest != (unsigned char*)0) {
+                for (i = 0; i < 20; i += 4) {
+                        /* extracts the 8 least significant bits. */
+                        digest[i]     =  context->state[i>>2];
+                        digest[i + 1] = (context->state[i>>2] >>  8);
+                        digest[i + 2] = (context->state[i>>2] >> 16);
+                        digest[i + 3] = (context->state[i>>2] >> 24);
+                }
+        }
+}
+
diff -ruN qmail-1.03-orig/digest_rmd160.h qmail-1.03-ldap-20060201-orig/digest_rmd160.h
--- qmail-1.03-orig/digest_rmd160.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_rmd160.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,49 @@
+/* digest_rmd160.h for QLDAP modified to use djb's stuff */
+
+/*        */
+/* RMD160 */
+/*        */
+
+/********************************************************************\
+ *
+ *      FILE:     rmd160.h
+ *
+ *      CONTENTS: Header file for a sample C-implementation of the
+ *                RIPEMD-160 hash-function. 
+ *      TARGET:   any computer with an ANSI C compiler
+ *
+ *      AUTHOR:   Antoon Bosselaers, ESAT-COSIC
+ *      DATE:     1 March 1996
+ *      VERSION:  1.0
+ *
+ *      Copyright (c) Katholieke Universiteit Leuven
+ *      1996, All Rights Reserved
+ *
+\********************************************************************/
+
+#ifndef  _RMD160_H      /* make sure this file is read only once */
+#define  _RMD160_H
+
+/********************************************************************/
+#include "uint32.h"
+
+/* structure definitions */
+
+typedef struct {
+        uint32 state[5];     /* state (ABCDE) */
+        uint32 length[2];    /* number of bits */
+        unsigned char  bbuffer[64];    /* overflow buffer */
+        uint32 buflen;       /* number of chars in bbuffer */
+} RMD160_CTX;
+
+/********************************************************************/
+
+#define RMD160_LEN 20
+
+/* function prototypes */
+
+void RMD160Init(RMD160_CTX *);
+void RMD160Update(RMD160_CTX *, const unsigned char *, size_t);
+void RMD160Final(unsigned char [RMD160_LEN], RMD160_CTX *);
+
+#endif  /* _RMD160_H */
